	package
{
	import com.greensock.TweenLite;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.ColorCorrection;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Mouse;
	import flash.utils.Timer;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
//		[Embed(source = "data/pattern1.png")] public static var ImgPattern:Class;

		[Embed(source = "data/graphics/backgrounds-animation.png")] private var ImgBg:Class;
		[Embed(source = "data/graphics/allframes.png")] private var ImgWalkCycle:Class;
		[Embed(source = "data/graphics/screen.png")] private var ImgScreen:Class;
		
		[Embed(source = "data/sound/music.mp3")] public static var SndMusic:Class;
		[Embed(source = "data/sound/blip.mp3")] public static var SndBlip:Class;
		
		
		private var bg:FlxSprite;

		private var player:PlayerSprite;
		private var follower:FlxSprite;
		
		private var snaps:Vector.<FlxSprite>;
		
		[Embed(source = "data/graphics/fadebg.png")] public static var fadebg:Class; //hospital

		
		[Embed(source = "data/graphics/end scene hold wrist.png")] public var Snap1:Class; //hospital
		[Embed(source = "data/graphics/end scene eye bleed.png")] public var Snap0:Class; //hospital
		[Embed(source = "data/graphics/end scene pillow kiss.png")] public var Snap2:Class; //hospital
		
		[Embed(source = "data/graphics/frames-bed.png")] public var ImgNPC0:Class; //hospital
		[Embed(source = "data/graphics/frames-mother.png")] public var ImgNPC1:Class; 	//mother
		[Embed(source = "data/graphics/frames-falloffladder.png")] public var ImgNPC2:Class; //ladder
		[Embed(source = "data/graphics/frames-street.png")] public var ImgNPC3:Class; //bum
		[Embed(source = "data/graphics/frames kite.png")] public var ImgNPC4:Class; //kite
		[Embed(source = "data/graphics/frames-victim.png")] public var ImgNPC5:Class; //victim
		[Embed(source = "data/graphics/frames-restaurant.png")] public var ImgNPC6:Class; //restaurant
		[Embed(source = "data/graphics/frames-falloffladder.png")] public var ImgNPC7:Class; //hospital
		[Embed(source = "data/graphics/frames-patient.png")] public var ImgNPC8:Class; //hospital
		
		private var npcdimensions:Array = [
			[64,64], //0 bed
			[36,44],//1	mother
			[80,103],//2 ladder
			[64,64],//3 bum
			[64,128],//4 kite
			[64,32],//5 victim
			[64,64],//6 restaurant
			[64,64],//7 blank
			[64,64] //8 hospital
			];
		
		private var npcxoffsets: Array = 
			[
				-100, //0 bed
				756,//1 mother
				981,//2 ladder
				1721,//3 bum
				2387,//4 kite
				3127,//5 victim
				4073,//6 restaurant
				-100,//7 blank
				7262+29,//8 hospital
				];
		
		private var npcyoffsets: Array = 
			[
				0,//0 bed
				0,//1 mother
				0,//2 ladder
				0,//3 bum
				-19,//4 kite
				0,//5 victim
				0,//6 restaurant
				0,//7 blank
				0-6,//8 hospital
			];
		
		private var npcanims:Array = [
			//0 bed (blank)
			[
				//name,start,stop,rate,loop
				["idle",0,0,5,false],
			],
			//1	//MOTHER
			[
				//name,start,stop,rate,loop
				["idle",0,10,5,true],
				["talk-in",11,15,5,false],
				["talk",16,20,5,false],
				["talk-idle",21,29,5,false],
			],
			//2 //LIGHTBULB
			[
				//name,start,stop,rate,loop
				["idle",25,39,5,true],
				["fall",0,24,5,false],
				["talk",40,43,5,false],
				["dead",42,42,5,false],
			],
			//3 //STREETBUM
			/*
			0-14	death		6fps
			15-30	talk-in		6fps
			31-36	talk-idle	6fps
			37-40	talk-loop	6fps
			41-46	idle		6fps
			*/
			[
				//name,start,stop,rate,loop
				["idle",41,46,6,true],
				["talk-in",15,30,6,false],
				["talk-idle",31,36,6,true],
				["talk-loop",37,40,6,false],
				["death",0,14,6,false],
				["dead",14,14,6,false]
			],
			//4 KITE
			[
				//name,start,stop,rate,loop
				["idle",0,3,5,true],
				["talk",4,7,5,false, "idle"],
				["fall",8,21,4,false]
			],
			//5 VICTIM
			[
				//name,start,stop,rate,loop
				["idle",0,7,3,true],
				["talk",8,11,5,false],
				["death",12,12,4,false]
			],
			//6 RESTAURANT
			[
				//name,start,stop,rate,loop
				["idle",0,9,5,true],
				["talk",10,15,5,false],
				["death",16,24,4,false]
			],
			//7 BLANK
			[
				//name,start,stop,rate,loop
				["idle",0,0,5,false],
			],
			//8 HOSPITAL
			[
				//name,start,stop,rate,loop
				["idle",0,0,5,true],
				["talk",1,4,4,false],
				["fall",0,0,5,false]
			],
			];
		
		
		
		private var textboxoffset:Array = [
			//0 bed (blank)
			[
				93,90,
				93,90
			],
			//1	//MOTHER
			[
				67,103,
				139,103
			],
			//2 //LIGHTBULB
			[
				9,90,
				127,66
			],
			//3 //STREET BUM
			/*
			0-14	death		6fps
			15-30	talk-in		6fps
			31-36	talk-idle	6fps
			37-40	talk-loop	6fps
			41-46	idle		6fps
			*/
			[
				70,106,
				117,109
			],
			//4 KITE
			[
				103,89,
				137,49
			],
			//5 VICTIM
			[
				65,105,
				119,105
			],
			//6 RESTAURANT
			[
				74,108,
				135,108
			],
			//7 GRAVEYARD
			[
				69,103,
				69,103
			],
			//8 HOSPITAL
			[
				144,95,
				194,95
			]
		];
		
		private var npcs:Vector.<FlxSprite>;
		
		private const PLAYER:int = 1;
		private const OTHER:int = 2;
		
		private var animation:Vector.<AnimationLine>;
		private var conversation:Vector.<ConversationLine>;
		private var conversationpos:int;
		
		private function NOLINE():void
		{
			LINE(-1,"");
		}
		
		private function LINE(speaker:int,text:String):void
		{
			
			if (conversation.length+1!=animation.length)
			{
				trace("ERROR ERROR ERROR NOTSAME LENGTH" + speaker + " - " + text);
			}
			
			conversation.push(new ConversationLine(speaker,text));
		}
		
		private function ANIM(anim_player:String,anim_npc:String, block:Boolean, immediate:Boolean = false):void
		{
			animation.push(new AnimationLine(anim_player,anim_npc,block,immediate));
		}		
		
		private const conversationcount:int=9;
		private var conversationhad:Array;
		
		
		private var conversationspots:Array = 
			[
				0,//getting up
				685,//mother
				930,//lightbulb
				1669,//bum
				2292,//park
				3042,//carcrash
				4030,//restaurant
				5238,//graveyard
				7262,//final
			];
		
		private var curconv:int=-1;
		
		private function startConversation(i:int):void
		{
			curconv=i;
			conversation = new Vector.<ConversationLine>;
			animation = new Vector.<AnimationLine>;
			conversationpos=0;
			switch (i)
			{
				case 0: //getting up					
					ANIM("idle_right_nude","",false);
					LINE(PLAYER,"Ah...sleepy...");
					break;
				case 1: //with mother
					ANIM("idle_right_clothed","talk-in",true);
					NOLINE();

					ANIM("","talk",false);
					LINE(OTHER,"My darling daughter; you slept in!");
					ANIM("talk","",false);
					LINE(PLAYER,"I was feeling most unwell, Mammy.");
					ANIM("","talk",false);
					LINE(OTHER,"There's you complaining about a pain in the head, and aren't your wives all on the brink of death?")
					ANIM("talk","",false);
					LINE(PLAYER,"101,100|Pardon?");
					ANIM("","talk",false);
					LINE(OTHER,"164,103|Ha!");
					ANIM("","talk",false);
					LINE(OTHER,"Goes to show how much you care.");
					ANIM("talk","",false);
					LINE(PLAYER,"I don't believe I know of what you're talking.");
					ANIM("","talk",false);
					LINE(OTHER,"You would if it were in your interests.");
					ANIM("talk","",false);
					LINE(PLAYER,"I am more than adequately interested in my wifes, Mammy.");
					ANIM("","talk",false);
					LINE(OTHER,"139,79|It's not obvious. You've been spending all your time at the hospital;");
					ANIM("","talk",false);
					LINE(OTHER,"139,79|People might be led to think that you don't have any wives at all!");
					ANIM("talk","",false);
					LINE(PLAYER,"Heaven forbid my oncologist should get the wrong idea.");
					ANIM("","talk",false);
					LINE(OTHER,"125,99|You can't trust them!");
					ANIM("talk","",false);
					LINE(PLAYER,"67,101|Of course, Mammy, of course.");
					ANIM("talk","",false);
					LINE(PLAYER,"In any event, if what you say is true, then I should be getting on to say my farewells.");
					ANIM("","talk",false);
					LINE(OTHER,"139,79|Better you do that rather than dithering about here, then.");
					
					ANIM("idle_right_clothed","idle",true,true);
					NOLINE();

					break;
				case 2://bulb-change		
					ANIM("talk_a","",false);
					LINE(PLAYER,"64,101|Hello up there!");
					ANIM("","talk",false);
					LINE(OTHER,"Oh hello darling.");
					ANIM("talk_a","",false);
					LINE(PLAYER,"20,96|How many wifes does it take to change a light-bulb?");
					ANIM("","talk",false);
					LINE(OTHER,"Do you really mean to insult me like that?");
					ANIM("talk_a","",false);
					LINE(PLAYER,"20,98|My dear, I was just making a joke.");
					ANIM("","talk",false);
					LINE(OTHER,"It doesn't seem so funny from up here, toiling as I am for our household.");
					ANIM("talk_a","",false);
					LINE(PLAYER,"98,101|Oh now...");
					ANIM("","talk",false);
					LINE(OTHER,"Besides, I'm perfectly capable of doing this by myself.");
					ANIM("talk_a","",false);
					LINE(PLAYER,"20,91|Oh my dear, I don't mean to berate you; I would find it quite upsetting were you to...");
					ANIM("","talk",false);
					LINE(OTHER,"Don't put the blame on me! ");
					ANIM("talk_a","",false);
					LINE(PLAYER,"20,92|I'm not blaming anyone, I would hate for these last moments to be unpleasant...");
					ANIM("","talk",false);
					LINE(OTHER,"Be quiet! You're putting me o...aa..auua..");
					ANIM("","fall",true);
					NOLINE();
					ANIM("","",false);
					LINE(PLAYER,"114,105|...");
					ANIM("talk_c","",false);
					LINE(PLAYER,"99,101|My dear?");
					ANIM("","",false);
					LINE(PLAYER,"114,105|...");
					ANIM("","",false);
					LINE(PLAYER,"102,105|Oh well...");
					
					ANIM("idle_right_clothed","",true,true);
					NOLINE();
					break;
				case 3://bum	
					ANIM("idle_right_clothed","talk-in",true);
					NOLINE();
					ANIM("talk","",false);
					LINE(PLAYER,"89,100|You're drunk.");
					ANIM("","talk-loop",false);
					LINE(OTHER,"Yyou never leave me for a moment in any doubt of why I left you.");
					ANIM("talk","talk-idle",false);
					LINE(PLAYER,"You truly are the most terrible of all possible women.");
					ANIM("","talk-loop",false);
					LINE(OTHER,"119,97|You think me possible?");
					ANIM("talk","talk-idle",false);
					LINE(PLAYER,"At a stretch I could be pushed to term you likely.");
					ANIM("","talk-loop",false);
					LINE(OTHER,"120,97|How things have changed;");
					ANIM("","talk-loop",false);
					LINE(OTHER,"You used to scream out declarations of my existence when me made love.");
					ANIM("talk","talk-idle",false);
					LINE(PLAYER,"Your reality was never as lucid as during intercourse.");
					ANIM("","talk-loop",false);
					LINE(OTHER,"Sometimes, even when we were in public, you would tease me and hint at my existence.");
					ANIM("talk","talk-idle",false);
					LINE(PLAYER,"The grand flirtatiousness of the newlyweds...");
					ANIM("","talk-loop",false);
					LINE(OTHER,"Our relationship was entirely platonic.");
					ANIM("talk","talk-idle",false);
					LINE(PLAYER,"My epistemology was platonic, our relationship was anything but.");
					ANIM("","talk-loop",false);
					LINE(OTHER,"What was it that you said in the end?");
					ANIM("","talk-loop",false);
					LINE(OTHER,"You said that you \"lacked the ontological commitment\" to stay with me.");
					ANIM("talk","talk-idle",false);
					LINE(PLAYER,"It is inconceivable that I ever could intend to hurt you.");
					ANIM("","talk-loop",false);
					LINE(OTHER,"119,103|And yet you did.");
					ANIM("talk_b","talk-idle",false);
					LINE(PLAYER,"98,106|Yes, I did.");
					ANIM("","",false);
					LINE(PLAYER,"114,105|...");
					ANIM("talk_b","",false);
					LINE(PLAYER,"96,105|I'm sorry.");
					ANIM("","talk",false);
					LINE(OTHER,"128,105|Sorry about what?");
					ANIM("talk_a","talk-idle",false);
					LINE(PLAYER,"66,105|I'm sorry I ever doubted you.");
					ANIM("","talk",false);
					LINE(OTHER,"You've hurt me so much.");
					ANIM("talk","talk-idle",false);
					LINE(PLAYER,"Maybe, but it'll be drink that'll do you in : I wash my hands.");
					ANIM("","talk",false);
					LINE(OTHER,"I'm sorry you had to find out this way.");
					ANIM("talk","talk-idle",false);
					LINE(PLAYER,"75,105|You break my heart.");
					ANIM("idle_right_clothed","talk",false);
					LINE(OTHER,"122,105|Let me be, then.");
					break;
				case 4://bridge / kite
					ANIM("wave_park","idle",true);
					LINE(-1,"");
					
					ANIM("","talk",false);
					LINE(OTHER,"171,49|My husband!");
					ANIM("talk_park","idle",false);
					LINE(PLAYER,"103,100|Oh my darling!");
					ANIM("","talk",false);
					LINE(OTHER,"The weather today is so clement.");
					ANIM("talk_park","idle",false);
					LINE(PLAYER,"66,90|Indeed my wife, the air is so light, and of charming humidity.");
					ANIM("","talk",false);
					LINE(OTHER,"Why don't you come over here to me, dear?");
					ANIM("talk_park","idle",false);
					LINE(PLAYER,"65,92|I fear I may not have time.");
					ANIM("","talk",false);
					LINE(OTHER,"176,49|In a rush?");
					ANIM("talk_park","idle",false);
					LINE(PLAYER,"68,90|No, my dear, I fear you are about to die.");
					ANIM("","talk",false);
					LINE(OTHER,"170,52|Oh don't be...");
					ANIM("","idle",false);
					LINE(OTHER,"194,49|...");
					
					ANIM("","fall",true);
					NOLINE();
					ANIM("","",false);
					LINE(PLAYER,"104,90|There was little more joyful than the idle chitchats we shared.");
					ANIM("","",false);
					LINE(PLAYER,"104,90|I fear I shall never so thoroughly enjoy such vapid intercourse again.");
					
					ANIM("idle_right_clothed","",true,true);
					NOLINE();
					break;
				case 5://carcrash
					
					ANIM("talk","",false);
					LINE(PLAYER,"Oh my; I don't suppose there's any point inquiring if you're alright?");
					ANIM("","talk",false);
					LINE(OTHER,"I'm sure you don't need me to inform you of the utter severity of my situation.");
					ANIM("talk","",false);
					LINE(PLAYER,"Yes.  It's rather unfortunate isn't it.");
					ANIM("","talk",false);
					LINE(OTHER,"153,105|Don't mock me");
					ANIM("talk","",false);
					LINE(PLAYER,"I was only joking -");
					ANIM("","talk",false);
					LINE(OTHER,"I'm sorry to tell you, my love, but your humour doesn't seem to work as well from the vantage point of one crushed under the weight of a rented car.");
					ANIM("talk","",false);
					LINE(PLAYER,"Really? Let me investigate.");
					ANIM("lie_down","",true);
					NOLINE();
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"Why did the goose stride the firmament?");
					ANIM("","talk",false);
					LINE(OTHER,"168,105|Don't...");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"To soften the jeers of the foes of love.");
					ANIM("","",false);
					LINE(PLAYER,"121,105|...");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"85,105|You're right - ");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"That doesn't work at all.");
					ANIM("","talk",false);
					LINE(OTHER,"Yes, it's rather unfortunate.");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"And what of the other driver?");
					ANIM("","talk",false);
					LINE(OTHER,"I doubt she would be any more amused.");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"I mean, where is she?");
					ANIM("","talk",false);
					LINE(OTHER,"134,105|She fled the scene.");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"65,99|Had I happened here earlier, I would have chased after her.");
					ANIM("","talk",false);
					LINE(OTHER,"161,107|I don't doubt it.");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"Hmm.  The precariousness of this position, I confess, makes me feel rather uncomfortable.");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"63,100|Would you begrudge my getting up?");
					ANIM("","talk",false);
					LINE(OTHER,"126,85|Not at all.  You must be off anyway; you have to go pick up your results today.");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"Don't remind me, please.");
					ANIM("","talk",false);
					LINE(OTHER,"119,98|If I didn't remind you you'd only forget.");
					ANIM("lie_down_talking","",false);
					LINE(PLAYER,"You're right; I should be off.");	
					ANIM("get_up","",true);
					NOLINE();
					ANIM("talk","",false);
					LINE(PLAYER,"75,106|Good bye my darling.");
					
					ANIM("idle_right_clothed","death",true);
					NOLINE();
					break;
				case 6://restaurant					
					ANIM("idle_right_clothed","talk",false);
					LINE(OTHER,"Oh good; you're back.");	
					ANIM("talk","",false);
					LINE(PLAYER,"Excuse me, my dear; I got rather diverted on my way back from the lavatory.");
					ANIM("","talk",false);
					LINE(OTHER,"I ordered the steak for you.");
					ANIM("talk","",false);
					LINE(PLAYER,"103,108|Yummy.");
					ANIM("","talk",false);
					LINE(OTHER,"Oh yes: so I was reading that book I told you about last night.");
					ANIM("talk","",false);
					LINE(PLAYER,"87,89|Thinking of me?");
					ANIM("","158,89|talk",false);
					LINE(OTHER,"167,108|Yes.");
					ANIM("","talk",false);
					LINE(OTHER,"I was his lover, as he wrote that, the author.");
					ANIM("talk","",false);
					LINE(PLAYER,"This was...before?");
					ANIM("","talk",false);
					LINE(OTHER,"No, at the point of orgasm");
					ANIM("talk","",false);
					LINE(PLAYER,"He produced it in an instant?");
					ANIM("","talk",false);
					LINE(OTHER,"Actually, it lasted several weeks.");
					ANIM("talk","",false);
					LINE(PLAYER,"95,105|Fascinating.");
					ANIM("talk","",false);
					LINE(PLAYER,"Did he pay you for your services?");
					ANIM("","talk",false);
					LINE(OTHER,"No; he only gave me a pat on the bottom.  I didn't know what to make of it.");
					ANIM("talk","",false);
					LINE(PLAYER,"I suspect he wasn't fully certain himself.");
					ANIM("","talk",false);
					LINE(OTHER,"He was entirely certain of his own rigor; it was in everything else he saw ambiguity.");
					ANIM("talk","",false);
					LINE(PLAYER,"And what were you?");
					ANIM("","talk",false);
					LINE(OTHER,"To him? I was his Coy Mistress with The Sweetly Yielding Buttocks.");
					ANIM("talk","",false);
					LINE(PLAYER,"Coy? But I always found you to be perfectly forthright.");
					ANIM("","talk",false);
					LINE(OTHER,"Yes, well you lacked the ability to take anything I said anything other than literally.");
					ANIM("talk","",false);
					LINE(PLAYER,"You mean you were saying other things the whole time?");
					ANIM("","talk",false);
					LINE(OTHER,"Don't be absurd.  I was saying what I said; I never uttered a word except to say it.");
					ANIM("talk","",false);
					LINE(PLAYER,"Do you mean it?");
					ANIM("","talk",false);
					LINE(OTHER,"140,113|It was meant.");
					ANIM("talk","",false);
					LINE(PLAYER,"I couldn't settle with that.");
					ANIM("","talk",false);
					LINE(OTHER,"But you stayed with me for nine whole years.");
					ANIM("talk","",false);
					LINE(PLAYER,"And for nine years I battled with my conscience.");
					ANIM("","talk",false);
					LINE(OTHER,"Yes; it left me as something of a third party.");
					ANIM("","talk",false);
					LINE(OTHER,"But now it is your time to leave me.");
					ANIM("talk","",false);
					LINE(PLAYER,"Yes.  I had come to bid you farewell.");
					ANIM("","talk",false);
					LINE(OTHER,"You've changed your mind in the interim?");
					ANIM("talk","",false);
					LINE(PLAYER,"Time has run out; I must move on.");
					ANIM("","talk",false);
					LINE(OTHER,"167,108|Oh.");
					ANIM("","talk",false);
					LINE(OTHER,"But what about your steak?");
					ANIM("talk","",false);
					LINE(PLAYER,"I don't think I might savour it, not really.");
					ANIM("","talk",false);
					LINE(OTHER,"But it will be perfectly lovely!");
					ANIM("talk","",false);
					LINE(PLAYER,"I don't have a moment to spare, my love. ");
					ANIM("idle_right_clothed","death",false);
					NOLINE();
					break;
				case 7://graveyard
					ANIM("talk","",false);
					LINE(PLAYER,"Alas, it seems I was too late here.");
					ANIM("talk","",false);
					LINE(PLAYER,"She died a full twenty years before I was born, and yet I can remember the first time we met as if it were yesterday.");
					ANIM("talk","",false);
					LINE(PLAYER,"I can remember the first time I set eyes on her, as I pried open her casket.");
					ANIM("talk","",false);
					LINE(PLAYER,"I can remember our first kiss, so yielding were her sweetly whither'd lips.");
					ANIM("talk","",false);
					LINE(PLAYER,"Yet now she's dead and gone, have I realized.");
					ANIM("talk","",false);
					LINE(PLAYER,"Oh why have I been burden'd with this fate?");
					
					ANIM("idle_right_clothed","",true,true);
					NOLINE();
					break;
				case 8://hospital
					ANIM("idle_right_clothed","talk",false);
					LINE(OTHER,"220,102|Oh my husband.");
					ANIM("talk","",false);
					LINE(PLAYER,"184,104|Hello.");
					ANIM("","talk",false);
					LINE(OTHER,"It's so good to see you.");
					ANIM("talk","",false);
					LINE(PLAYER,"144,92|I'm sorry I've been away for so long.");
					ANIM("talk","",false);
					LINE(PLAYER,"144,92|I just went to fetch a sandwich...");
					ANIM("","talk",false);
					LINE(OTHER,"Don't worry about that, my darling; you're here now.");
					ANIM("talk","",false);
					LINE(PLAYER,"How are you holding up?");
					ANIM("","talk",false);
					LINE(OTHER,"Oh, you know what doctors are like.");
					ANIM("","talk",false);
					LINE(OTHER,"What about you?");
					ANIM("","talk",false);
					LINE(OTHER,"Did you hear back about your results?");
					ANIM("talk","",false);
					LINE(PLAYER,"Yes, though...I can't remember what they said.");
					ANIM("","talk",false);
					LINE(OTHER,"Are you feeling okay?");
					ANIM("talk","",false);
					LINE(PLAYER,"I don't know; I feel as if I might ... disintegrate.");
					ANIM("","talk",false);
					LINE(OTHER,"You're falling apart?");
					ANIM("talk","",false);
					LINE(PLAYER,"I feel as if I might.");
					ANIM("","talk",false);
					LINE(OTHER,"How long have you waited to tell me?");
					ANIM("talk","",false);
					LINE(PLAYER,"Since we first met.");
					ANIM("talk","",false);
					LINE(PLAYER,"117,83|When I first saw you, across the canal, I knew that I wanted to tell you everything.");
					ANIM("","talk",false);
					LINE(OTHER,"Why did you wait so long?");
					ANIM("talk","",false);
					LINE(PLAYER,"122,100|I wanted to tell you -");
					ANIM("talk","",false);
					LINE(PLAYER,"117,89|At every instant I was terrified that a moment would pass,");
					ANIM("talk","",false);
					LINE(PLAYER,"117,81|and I would no longer be in a position to tell you, or you would no longer be inclined to listen.");
					ANIM("","talk",false);
					LINE(OTHER,"207,95|I'm not much able for else than listening nowadays;");
					ANIM("","talk",false);
					LINE(OTHER,"194,55|Your disclosure is thusly stretching my abilities to capacity, is as generally fulfilling an activity as I can hope for at this stage of my life to cope with.");
					ANIM("talk","",false);
					LINE(PLAYER,"I don't mean to burden you in your final moments.");
					ANIM("","talk",false);
					LINE(OTHER,"My final moments? You're not looking the best shape yourself.");
					ANIM("talk","",false);
					LINE(PLAYER,"184,103|Yes.");
					ANIM("","",false);
					LINE(PLAYER,"184,103|...");
					ANIM("talk","",false);
					LINE(PLAYER,"143,83|I'm feeling rather tired.  Would you mind if I joined you?");
					ANIM("","talk",false);
					LINE(OTHER,"Don't be so morbid");
					ANIM("","",false);
					LINE(PLAYER,"184,103|...");
					ANIM("talk","",false);
					LINE(PLAYER,"156,103|I'm going to die.");
					ANIM("","talk",false);
					LINE(OTHER,"I know; your father was here this morning and told me.");
					ANIM("","",false);
					LINE(PLAYER,"184,103|...");
					ANIM("talk","",false);
					LINE(PLAYER,"120,91|We are the only two left, and you in better shape than I.");
					ANIM("","",false);
					LINE(PLAYER,"184,103|...");
					ANIM("talk","",false);
					LINE(PLAYER,"139,104|Won't you reconsider?");
					ANIM("","talk",false);
					LINE(OTHER,"205,94|Oh alright then.  I shall not object if you join me now.");
					ANIM("talk","",false);
					LINE(PLAYER,"163,101|Thank you.");
					
					ANIM("get_into_bed","",true);
					NOLINE();
					
					ANIM("in_bed_talking","",false);
					LINE(PLAYER,"166,109|My dear?");
					ANIM("","talk",false);
					LINE(OTHER,"218,110|Yes, love?");
					ANIM("in_bed_talking","",false);
					LINE(PLAYER,"121,104|What do you think shall come of us?");
					ANIM("","talk",false);
					LINE(OTHER,"201,107|I imagine we shall die soon.");
					ANIM("in_bed_talking","",false);
					LINE(PLAYER,"116,112|No, but after that.");
					ANIM("","talk",false);
					LINE(OTHER,"199,89|I imagine the best we can hope for is to receive a thorough ravishing from one of your proteges.");
					
					ANIM("","",false);
					LINE(PLAYER,"187,114|...");
										
					ANIM("","talk",false);
					LINE(OTHER,"206,112|Your... your eye is bleeding.");
					
					ANIM("in_bed_talking","",false);
					LINE(PLAYER,"154,116|What? What?");										
										
					//[ player character reaches to touch area around eye, sees blood on finger ]
					ANIM("snap0","",false);
					LINE(OTHER,"");					
					
					ANIM("","talk",false);
					LINE(OTHER,"212,120|Don't worry");					
					
					ANIM("","talk",false);
					LINE(OTHER,"207,120|Here, give me your hand -");										
					
					//[ player character reaches to touch area around eye, sees blood on finger ]
					ANIM("snap1","",false);
					LINE(OTHER,"");
					
					//[ gives player a comforting squeeze on the wrist ]
					ANIM("","talk",false);
					LINE(OTHER,"193,116|it means that you're becoming a woman");
					ANIM("in_bed_talking_pose2","",false);
					LINE(PLAYER,"139,121|but...I'm dying");
					
					
					//[ player character reaches to touch area around eye, sees blood on finger ]
					ANIM("snap2","",false);
					LINE(OTHER,"");
					
					//[ wife kisses player gently on the lips ]
					//fade to black, then 'the end' appears
					break;
			}
			
			if (conversation.length>0)
			{
				speaking=conversation[0].speaker;
			}
			
			ConvRender();
		}
		private var wait:Boolean=false;
		
		private var boxwidth:int=150;
		private function ConvRender():void
		{
			if (conversation.length==0)
			{
				speaking=0;
				//text.visible=false;
				TweenLite.killTweensOf(text);
				TweenLite.to(text,0.2,{alpha:0});
				HideTextBG();
				return;
			}

			var anim:AnimationLine = animation[conversationpos];
			
			text.text=conversation[conversationpos].text;
			speaking=conversation[conversationpos].speaker;
			
			//trace(anim.anim_npc+","+anim.anim_player);
			if (anim.anim_npc!="")
			{
				if (anim.anim_npc=="snap0")
				{					
					snaps[0].visible=true;
					snaps[0].alpha=0;
					TweenLite.to(snaps[0],1,{alpha:1});
					anim.anim_npc="";
				}
				else if (anim.anim_npc=="snap1")
				{
					snaps[1].visible=true;
					snaps[1].alpha=0;
					TweenLite.to(snaps[1],1,{alpha:1});
					anim.anim_npc="";				
				}
				else if (anim.anim_npc=="snap2")
				{					
					snaps[2].visible=true;
					snaps[2].alpha=0;
					TweenLite.to(snaps[2],1,{alpha:1});
					anim.anim_npc="";
				}
				
				{
					npcplay(anim.anim_npc);
				}
			}
			
			if (anim.anim_player!="")
			{				
				if (anim.anim_player=="snap0")
				{					
					snaps[0].visible=true;
					snaps[0].alpha=0;
					TweenLite.to(snaps[0],1,{alpha:1});
					anim.anim_player="";
				}
				else if (anim.anim_player=="snap1")
				{
					snaps[1].visible=true;
					snaps[1].alpha=0;
					TweenLite.to(snaps[1],1,{alpha:1});
					anim.anim_player="in_bed_reach_for_wife";
				}
				else if (anim.anim_player=="snap2")
				{					
					snaps[2].visible=true;
					snaps[2].alpha=0;
					TweenLite.to(snaps[2],1,{alpha:1});
					anim.anim_player="";
				}
				
				if (anim.anim_player=="talk")
				{
					switch (int(Math.random()*3))
					{
						case 0:
							anim.anim_player="talk_a";
							break;
						case 1:
							anim.anim_player="talk_b";
							break;
						case 2:
							anim.anim_player="talk_c";
							break;
					}
				}
				if (anim.anim_player=="get_into_bed")
				{
					player.x+=24;
				}
				//trace("player.play " + anim.anim_player);
				if (anim.anim_player!="")
				{
					player.play(anim.anim_player,true);
				}
			}
			
			wait = anim.block;
			
			if (anim.immediate)
			{
				player.finished=true;
				
				var npc:FlxSprite = npcs[curconv];
				npc.finished=true;
			}
			
			if (speaking>=0)
			{				
				TweenLite.killTweensOf(text);
				text.visible=true;
				text.alpha=0;
				TweenLite.to(text,0.2,{alpha:1});
				SetTextBG();
				
				text.x= textboxoffset[curconv][speaking==1?0:2];
				text.y= textboxoffset[curconv][speaking==1?1:3]+13.95-text.height;
				
				var ind:int = text.text.indexOf("|");
				if (ind>=0)
				{
					var ar:Array = text.text.split("|");
					var coords:Array = String(ar[0]).split(",");
					text.text=ar[1];
					text.x=Number(coords[0]);
					text.y=Number(coords[1]);
				}
				
				SetTextBG();
				
				//trace(text.height);
			}
			else
			{
				//text.visible=false;
				TweenLite.killTweensOf(text);
				TweenLite.to(text,0.2,{alpha:0});
				HideTextBG();
			}
		}
		//public var followoffset:Number = 100;
		public var followoffset:Number = 80;
		private var clothed:Boolean;
		private var sleeping:Boolean;
		private var text:FlxText;
		private var textbg1:FlxText;
		private var textbg2:FlxText;
		private var textbg3:FlxText;
		private var textbg4:FlxText;
		private var textbg5:FlxText;
		private var textbg6:FlxText;
		private var textbg7:FlxText;
		private var textbg8:FlxText;
		
		
		private var screenspr:FlxSprite;
		private var speaking:int;
		override public function create():void
		{			
			bgColor=0xff000000;
			FlxG.flash.start(0xff000000);
			sleeping=true;
			facing=FlxSprite.RIGHT;
			super.create();
			clothed=false;
			conversationhad = new Array();
			conversationpos=0;
			speaking=0;
			conversation = new Vector.<ConversationLine>();
			FlxG.playMusic(SndMusic);
			bg = new FlxSprite(0,0);
			bg.loadGraphic(ImgBg,true,false,7429,240);
			bg.addAnimation("default",[0,1,2],4);
			this.add(bg);
			bg.play("default");
			
			player = new PlayerSprite(99,116);
			player.loadGraphic(ImgWalkCycle,true,false,64,64);
			player.addAnimationRange("walk_left_clothed",	0,7,6,true);
			player.addAnimationRange("walk_right_clothed",	8,15,6,true);
			player.addAnimationRange("walk_left_nude",		16,23,6,true);
			player.addAnimationRange("walk_right_nude",		24,31,6,true);
			player.addAnimationRange("idle_left_clothed",	32,39,5,true);
			player.addAnimationRange("idle_right_clothed",	40,47,5,true);
			player.addAnimationRange("idle_left_nude",		48,55,5,true);
			player.addAnimationRange("idle_right_nude",		56,63,5,true);
			player.addAnimationRange("sleep_cycle",			64,71,3,true);
			player.addAnimationRange("get_out_of_bed_anim",	72,101,5,false);
			player.addAnimationRange("idle_park",			104,111,5,true);
			player.addAnimationRange("talk_park",			112,119,5,false);
			player.addAnimationRange("wave_park",			120,127,5,false);
			player.addAnimationRange("talk_a",				128,135,5,false);
			player.addAnimationRange("talk_b",				136,151,5,false);
			player.addAnimationRange("talk_c",				152,159,5,false);
			player.addAnimationRange("talk_down",			160,167,5,false);
			player.addAnimationRange("talk_down_idle",		168,175,5,false);
			player.addAnimationRange("lie_down",			176,191,5,false);
			player.addAnimationRange("down_static_frame",	192,192,5,true);
			player.addAnimationRange("lie_down_talking",	192,199,5,false);
			player.addAnimationRange("get_up",				200,215,5,false);
			player.addAnimationRange("get_into_bed",		216,224,5,false);
			player.addAnimationRange("in_bed_talking",		225,228,5,false);
			player.addAnimationRange("in_bed_reach_for_wife",229,231,5,false);
			player.addAnimationRange("in_bed_talking_pose2",231,235,5,false);

			
			npcs = new Vector.<FlxSprite>();
			for (var i:int=0;i<9;i++)
			{
				var npc:FlxSprite = new FlxSprite(npcxoffsets[i],npcyoffsets[i]+180-int(npcdimensions[i][1]));
				npc.loadGraphic(this["ImgNPC"+i],true,false,npcdimensions[i][0],npcdimensions[i][1]);
				//trace("loading");
				for (var j:int=0;j<npcanims[i].length;j++)
				{
					var ar:Array = npcanims[i][j];
					trace(ar[0]);
					if (ar.length==6)
					{
						npc.addAnimationRange(ar[0],ar[1],ar[2],ar[3],ar[4],ar[5]);					
					}
					else
					{
						npc.addAnimationRange(ar[0],ar[1],ar[2],ar[3],ar[4]);
					}
					
					//name,start,stop,rate,loop
					//	["walk",0,24,5,false],
					
				}
				npc.play(npcanims[i][0][0],true);
				add(npc);
				npcs.push(npc);								
			}
			
			
			//player.addAnimation("walkright",[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14],15,true);
			//player.addAnimation("walkleft",[15,16,17,18,19,20,21,22,23,24,25,26,27,28,29],15,true);
			//player.addAnimation("idle_right_nude",[30],5,true);
			player.play("sleep_cycle",true);
			player.maxVelocity=new FlxPoint(100,100);
		//	player.drag=new FlxPoint(10,10);
			this.add(player);
			screenspr=new FlxSprite(122+210/2,148-62/2,ImgScreen)
			this.add(screenspr);
			
			follower = new FlxSprite(player.x+followoffset,player.y);
			//follower = new FlxSprite(player.x+100,player.y);
			follower.visible=false;
			this.add(follower);
			
			snaps = new Vector.<FlxSprite>();
			for (i=0;i<3;i++)
			{
				var ss:FlxSprite = new FlxSprite(0,0,this["Snap"+i]);
				snaps.push(ss);
				this.add(ss);
				ss.visible=false;
				ss.scrollFactor = new FlxPoint(0,0);
			}
			
			for (i=1;i<=8;i++)
			{
				var textbg:FlxText = new FlxText(0,0,boxwidth,"");
				textbg.scrollFactor = new FlxPoint(0,0);
				textbg.color=0xffffffff;
				this["textbg"+i] = textbg;
				add(textbg);
			}
			
			text = new FlxText(0,0,boxwidth,"");
			text.scrollFactor=new FlxPoint(0,0);
			text.color=0xff465672;
			//text.size=12;x
			add(text);
			
			FlxG.followTarget=follower;
			FlxG.followBounds(0,0,bg.width,240,true);						
			
			presstxt = new FlxText(122,130,50,"[x]");	
			presstxt.color=0xff000000;
			presstxt.alpha=0;
			add(presstxt);
			TweenLite.to(presstxt,3,{alpha:1});
			
			
		}
		
		public function SetTextBG():void
		{
			textbg1.x=text.x-1;
			textbg1.y=text.y-1;
			
			textbg2.x=text.x;
			textbg2.y=text.y-1;
			
			textbg3.x=text.x+1;
			textbg3.y=text.y-1;
			
			textbg4.x=text.x-1;
			textbg4.y=text.y;
			
			textbg5.x=text.x+1;
			textbg5.y=text.y;
			
			textbg6.x=text.x-1;
			textbg6.y=text.y+1;
			textbg7.x=text.x;
			textbg7.y=text.y+1;
			textbg8.x=text.x+1;
			textbg8.y=text.y+1;
			
			for (var i:int=1;i<=8;i++)
			{			
				var textbg:FlxText = this["textbg"+i] as FlxText;
				textbg.text = text.text;
				TweenLite.killTweensOf(textbg);
				textbg.alpha=0;				
				TweenLite.to(textbg,0.2,{alpha:1});
			}
		}

		public function HideTextBG():void
		{
			for (var i:int=1;i<=8;i++)
			{
				var textbg:FlxText = this["textbg"+i] as FlxText;
				TweenLite.killTweensOf(textbg);
				TweenLite.to(textbg,0.2,{alpha:0});
			}
		}
		
		public var presstxt:FlxText;
		public var facing:uint;
		
		private var talkanim:String ="";
		private var idleanim:String ="";
		private var npctalkanim:String ="";
		private var npcidleanim:String ="";
		
		private function npcplay(s:String):void
		{
			if (s=="")
				return;
			trace("npc.play " + s);
			if (curconv<0)
				return;
			var npc:FlxSprite = npcs[curconv];
			npc.play(s,true);			
		}
		
		private function idle():void
		{
			var s:String = "idle_";
			if (facing==FlxSprite.LEFT)
			{
				s+="left_";
			}
			else
			{
				s+="right_";
			}
			if (clothed)
			{
				s+="clothed";
			}
			else
			{
				s+="nude";
			}
			
			if (speaking && (player.x>2292-50&&player.x<2292+50))
			{
				s="idle_park";
			}
						
			if (idleanim!="")
				s=idleanim;
			
			player.play(s);
		}
		private function ContinueConversation():void
		{
			conversationpos++;
			
			if (conversationpos>=conversation.length)
			{
				speaking=0;
				TweenLite.to(text,1,{alpha:0});
				if (curconv==8)
				{
					gameover=true;
					FlxG.music.fadeOut(5);
					
					var fg:FlxSprite = new FlxSprite(0,0,fadebg);
					fg.visible=true;
					fg.scrollFactor = new FlxPoint(0,0);
					fg.alpha=0;
					add(fg);
					TweenLite.to(fg,5,{alpha:1});
					
					var txt:FlxText = new FlxText(0,FlxG.height/2-20,FlxG.width,"the end");
					txt.size=20;
					txt.color = 0xffffffff;
					txt.alpha=0;
					txt.alignment="center";
					txt.scrollFactor = new FlxPoint(0,0);
					txt.visible=true;
					TweenLite.to(txt,15,{alpha:1});
					add(txt);
				}
			}
			else 
			{
				ConvRender();
			}						
		}
		
		private var gameover:Boolean=false;
		
	
		private function npcfinished():Boolean
		{			
			if (curconv<0)
				return true;
			var npc:FlxSprite = npcs[curconv];
			return npc.finished;
		}
		
		
		private var leftbound:int = 5;
		private var fontnum:int = 0;
		override public function update():void
		{		
			if (gameover)
				return;
			
			if (FlxG.keys.justPressed("Y"))
			{
				text.size++;
				trace(text.font + " - " + text.size);
			}
			if (FlxG.keys.justPressed("U"))
			{
				text.size--;
				trace(text.font + " - " + text.size);
			}
			if (FlxG.keys.justPressed("I"))
			{
				fontnum = (fontnum+10)%11;
				text.font = "system"+fontnum;
				trace(text.font + " - " + text.size);
			}
			if (FlxG.keys.justPressed("O"))
			{
				fontnum = (fontnum+1)%11;
				text.font = "system"+fontnum;
				trace(text.font + " - " + text.size);
			}
			
			if (FlxG.keys.justPressed("D"))
			{				
				for (var i:int=0;i<conversationcount;i++)
				{
					conversationhad[i]=true;
				}
			}
			
			if (sleeping)
			{
				if (player.AnimName()!="get_out_of_bed_anim")
				{
					if (/*FlxG.mouse.justPressed()||*/ FlxG.keys.justPressed("SPACE")||FlxG.keys.justPressed("X")||FlxG.keys.justPressed("LEFT")||FlxG.keys.justPressed("RIGHT"))
					{
						//presstxt.visible=false;
						TweenLite.killTweensOf(presstxt);
						TweenLite.to(presstxt,0.5,{alpha:0});
						player.play("get_out_of_bed_anim",true);
					}
				}
				if (player.AnimName()=="get_out_of_bed_anim" && player.finished)
				{
					sleeping=false;
					idle();
				}
			}
			else if (speaking!=0)
			{
				
				/*
				if (FlxG.keys.LEFT)
				{
					text.x--;	
					trace(text.x+","+text.y);
				}
				if (FlxG.keys.RIGHT)
				{
					text.x++;		
					trace(text.x+","+text.y);			
				}
				if (FlxG.keys.UP)
				{
					text.y--;		
					trace(text.x+","+text.y);				
				}
				if (FlxG.keys.DOWN)
				{
					text.y++;					
					trace(text.x+","+text.y);
				}*/
				
				if (wait)
				{
					if (player.finished && npcfinished())
					{
						ContinueConversation();
						wait=false;
					}
				}				
				else
				{
					if (/*FlxG.mouse.justPressed()||*/FlxG.keys.justPressed("SPACE")||FlxG.keys.justPressed("X"))
					{
						ContinueConversation();
					}
				}
			}
			else
			{
				var playerspeed:Number=55;//55;
				var mleft:Boolean = FlxG.keys.LEFT;// || (FlxG.mouse.pressed() && FlxG.mouse.screenX < FlxG.width/2-5);
				var mright:Boolean = FlxG.keys.RIGHT;// || (FlxG.mouse.pressed() && FlxG.mouse.screenX >= FlxG.width/2+5);
				var moving:int = (mleft?-1:0) + (mright?1:0);
				var oldx:Number = player.x;
				//	if (FlxG.keys.S || FlxG.keys.SHIFT) playerspeed*=40;
				//this.text.visible=false;
				HideTextBG();
				TweenLite.killTweensOf(text);
				TweenLite.to(text,0.2,{alpha:0});
								
				if (moving!=0)
				{
					if (mleft)
					{
						leftbound = Math.max(leftbound,player.x-95);						
						
						player.x=Math.max(leftbound,player.x-playerspeed*FlxG.elapsed);
						if (player.x<=leftbound)
						{
							idle();
						}
						else
						{
							this.clothed=player.x>screenspr.x;
							facing=FlxSprite.LEFT;
							if (clothed)
							{
								player.play("walk_left_clothed");
							}
							else
							{
								player.play("walk_left_nude");							
							}
						}						
					}
					
					if (mright)
					{
						player.x=Math.min(bg.width-5,player.x+playerspeed*FlxG.elapsed);
						this.clothed=player.x>screenspr.x;
						facing=FlxSprite.RIGHT;
						if (clothed)
						{
							player.play("walk_right_clothed");
						}
						else
						{
							player.play("walk_right_nude");							
						}
												
					}
				}
				else
				{
					idle();
				}
				
				if (oldx<1768 && player.x>=1768)
				{					
					npcs[3].play("death");
				}
				
//				if (FlxG.keys.justPressed("I"))
//				{
//					player.QueueAnimation("walkright");
//				}
//				if (FlxG.keys.justPressed("O"))
//				{
//					player.QueueAnimation("walkleft");
//				}
				
				for (var j:int=0;j<conversationcount;j++)
				{
					if (player.x>conversationspots[j]&&!conversationhad[j] 
						//&& j>7//REMOVE THIS LINE LATER
					)
					{            
						if (j>0)
						{
							player.x=conversationspots[j]+1;
						}
						startConversation(j);
						conversationhad[j]=true;
					}
				}
			}

			var oldX:Number = follower.x;
			follower.x= player.x+followoffset;
			if (follower.x>200 && follower.x<oldX)
			{
				follower.x=oldX;
			}
			super.update();			
		}
		
		override public function postProcess():void
		{
//			var ct:ColorTransform=new ColorTransform();
//			ct.redMultiplier=2;
			
			
//			FlxG.buffer.colorTransform(FlxG.buffer.rect,ct);
		}
	}	

}


class ConversationLine {
	public var text:String;
	public var speaker:int;
	public function ConversationLine(i:int,s:String) 
	{
		speaker=i;
		text=s
	}
}


class AnimationLine {
	public var anim_player:String;
	public var anim_npc:String;
	public var block:Boolean;
	public var immediate:Boolean;
	public function AnimationLine(player:String,npc:String,_block:Boolean,_immediate:Boolean) 
	{
		anim_player=player;
		anim_npc=npc;
		block=_block;
		immediate=_immediate;
	}
}